--- old/usr/src/uts/i86pc/io/apix/apix.c	Sat Mar 10 03:57:36 2018
+++ new/usr/src/uts/i86pc/io/apix/apix.c	Sat Mar 10 03:57:36 2018
@@ -114,7 +114,8 @@
 static void apix_intx_set_shared(int irqno, int delta);
 static apix_vector_t *apix_intx_xlate_vector(dev_info_t *, int,
     struct intrspec *);
-static int apix_intx_alloc_vector(dev_info_t *, int, struct intrspec *);
+static int apix_intx_alloc_vector(dev_info_t *, ddi_intr_handle_impl_t *,
+    struct intrspec *);
 
 extern int apic_clkinit(int);
 
@@ -261,15 +262,6 @@
 	if (apix_enable == 0)
 		return (PSM_FAILURE);
 
-	/*
-	 * FIXME Temporarily disable apix module on Xen HVM platform due to
-	 * known hang during boot (see #3605).
-	 *
-	 * Please remove when/if the issue is resolved.
-	 */
-	if (get_hwenv() == HW_XEN_HVM)
-		return (PSM_FAILURE);
-
 	/* check for hw features if specified  */
 	if (apix_hw_chk_enable) {
 		/* check if x2APIC mode is supported */
@@ -1184,8 +1176,7 @@
 				return (PSM_FAILURE);
 			}
 			ispec = ((ihdl_plat_t *)hdlp->ih_private)->ip_ispecp;
-			*result = apix_intx_alloc_vector(dip, hdlp->ih_inum,
-			    ispec);
+			*result = apix_intx_alloc_vector(dip, hdlp, ispec);
 			break;
 		default:
 			return (PSM_FAILURE);
@@ -2523,17 +2514,20 @@
 }
 
 static int
-apix_intx_alloc_vector(dev_info_t *dip, int inum, struct intrspec *ispec)
+apix_intx_alloc_vector(dev_info_t *dip, ddi_intr_handle_impl_t *hdlp,
+    struct intrspec *ispec)
 {
 	int irqno;
 	apix_vector_t *vecp;
 
-	if ((irqno = apix_intx_xlate_irq(dip, inum, ispec)) == -1)
+	if ((irqno = apix_intx_xlate_irq(dip, hdlp->ih_inum, ispec)) == -1)
 		return (0);
 
-	if ((vecp = apix_alloc_intx(dip, inum, irqno)) == NULL)
+	if ((vecp = apix_alloc_intx(dip, hdlp->ih_inum, irqno)) == NULL)
 		return (0);
 
+	hdlp->ih_irq = irqno;
+
 	DDI_INTR_IMPLDBG((CE_CONT, "apix_intx_alloc_vector: dip=0x%p name=%s "
 	    "irqno=0x%x cpuid=%d vector=0x%x\n",
 	    (void *)dip, ddi_driver_name(dip), irqno,
